<template lang="pug">
	article#carpeta
		//-p
		header( v-if="carpeta" )
			hgroup
				h1 {{ carpeta.nombre | capitalizar }}
			nav
				.ruta( v-if="id != disco.id" )
					//- a(href="#", title="title") Mis Archivos
					//- a(href="#", title="title") Proyectos
					//- a(href="#", title="title") Cliente 1
					//- p( v-for="item in carpeta.camino" )
					router-link( to="/disco" ) Mi Unidad
					router-link( v-for="item in carpeta.camino", :key="item.id", to="/carpeta") {{ item.nombre | capitalizar }}
					span {{ carpeta.nombre | capitalizar }}

			.operaciones
				button( type='button', @click="subir", v-tooltip="'Subir'").subir
					vector(src="~@img/ico-subir.svg?inline")
				button( type="button", v-if="id != disco.id", @click="borrar", v-tooltip="'Eliminar'", ).eliminar: vector(src="~@img/ico-borrar.svg?inline")
				//-.grupo
					button( type="button" ).compartir: vector(src="~@img/ico-compartir.svg?inline")
					.campo: input(type="text", value="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700,900")
				.grupo(:class="{activo:compartir}")
					button( type="button", @click="compartirClick",v-tooltip="'Compartir'" ).compartir: vector(src="~@img/ico-compartir.svg?inline")
					.campo: input(type="text", "readonly", :value="enlace", @focus="$event.target.select()", @click.prevent="$event.target.select()")
				//-button( type="button" ).favorito: vector(src="~@img/ico-favorito.svg?inline")
				//-button( type="button" ).configurar: vector(src="~@img/ico-ajustes.svg?inline")
				button( type="button", @click="crear", v-tooltip="'Crear carpeta'" ).crear: vector(src="~@img/ico-agregar.svg?inline")
				//-button( type="button" ).subir: vector(src="~@img/ico-subir.svg?inline")
			//-.columnas
				.columna: h2 Archivo
				.columna: h2 Usuario
				.columna: h2 Acciones
		listado( @clicArchivo = "listadoClicArchivo" )

		section.detalle
			//--pre {{ this.carpeta.camino }}
			tarjeta(titulo="Carpeta", :expandir="true", v-if="carpeta")
				vector(slot="icono", src="@img/ico-carpeta.svg?inline")
				dl.propiedades
					//-dt Propietario:
					//-dd {{ carpeta.propietario }}
					//-dt Compartido:
					//-dd {{ carpeta.compartido }}
					dt Archivos:
					dd {{ archivos.length }}

					dt Creada:
					dd {{ carpeta.creada }}
					dt Modificada:
					dd {{ carpeta.modificada }}
					//-dt Carpetas:
					//-dd {{ carpeta.carpetas }}

				//-h4 Descripción:
				//-p {{ carpeta.descripción }}

			detalleArchivo( v-if="archivo", :archivo="archivo", ref="detalleArchivo")
</template>

<script>
	import Listado from "@/components/Listado";
	import Tarjeta from "@/components/Tarjeta";
	import IconoFichero from "@/components/IconoFichero";
	import DetalleArchivo from "@/components/DetalleArchivo";
	import { enlace as obtenerEnlace } from "@/api/carpetas";
	import { mapState, mapActions } from "vuex";

	export default {
		name: "Carpeta",
		data() {
			return {
				compartir: false,
				enlace: ""
			};
		},
		components: {
			Listado,
			Tarjeta,
			IconoFichero,
			DetalleArchivo
		},
		watch: {
			id(n, a) {
				if (this.id) {
					//this.obtenerArchivos({ id:this.id })
					this.obtenerCarpeta({ id: this.id });
					this.$el.scrollIntoView({
						behavior: "smooth",
						block: "start"
					});

					this.compartir = false;
				}
			}
		},
		computed: {
			id() {
				return this.$route.params.id || this.disco.id;
			},
			...mapState(["carpeta", "archivos", "archivo", "disco"])
		},
		methods: {
			listadoClicArchivo(id) {
				//console.log( "listadoClicArchivo", id );
				//this.seleccionarArchivo( id );
			},
			compartirClick() {
				this.compartir = !this.compartir;
				//console.log(obtenerEnlace);
				if (this.enlace == "") {
					obtenerEnlace(this.id).then(rpta => (this.enlace = rpta.url));
				}
			},
			subir() {
				//alert("subir");
				this.$root.$emit("archivo-subir");
			},
			borrar() {
				const pregunta =
					"Eliminar Carpeta.\nEsta acción eliminará la carpeta y todos los archivos que contiene.";
				let confirmacion = confirm(pregunta);
				if (confirmacion) {
					this.borrarCarpeta();
				}
			},
			crear() {
				const pregunta = "Ingresa el nombre de la nueva carpeta";
				let nombre = prompt(pregunta);
				if (nombre.length) {
					this.crearCarpeta(nombre);
				} else {
					alert("Debes ingresar un nombre");
				}
			},
			...mapActions([
				"obtenerArchivos",
				"obtenerCarpeta",
				"borrarCarpeta",
				"crearCarpeta"
			])
		},
		created() {
			//this.seleccionarCarpeta( this.id )
			this.obtenerCarpeta({ id: this.id });
			//this.obtenerArchivos({ id:this.id })
			this.$root.$on("archivo-actualizado", () => {
				this.obtenerCarpeta({ id: this.id, actualiza: true });
			});
		}
	};
</script>

<style lang="stylus" scoped>
	@import "~nib/index"
	@import "../stylus/base/utiles.styl"

	#carpeta
		display grid
		grid-template-areas "encabezado detalle" "listado detalle"
		grid-template-columns 5fr 2fr
		grid-template-rows min-content 1fr
		grid-gap 0 1rem
		align-content start
		align-items start

	header
		grid-area encabezado
		display grid
		justify-content stretch
		justify-items stretch
		grid-template-areas "titulo titulo" "ruta acciones" "columnas ."
		grid-template-columns auto 1fr
		grid-gap 0 1rem
		border-bottom 1px solid tint( azul, 60% )
		margin-bottom 1rem
		background-color fondo_listado
		border-radius .5rem .5rem 0 0

		hgroup
			grid-area titulo
			background-color azul
			color white
			padding .8rem 1rem
			display flex
			border-radius .5rem .5rem 0 0

			h1
				font-weight 500
				line-height 1
				font-size calcRem( 15 )

		nav
			display flex
			align-items center
			justify-content space-between
			padding .8rem 1rem
			line-height 1

			.ruta
				display flex

				// TODO: Optimizar esta parte
				span
					margin-right .5em
					font-size calcRem( 12 )
					color tint( azul, 55% )
					word-wrap normal
					white-space nowrap

				a
					text-decoration none
					margin-right .5em
					font-size calcRem( 12 )
					color tint( azul, 40% )
					display block
					word-wrap normal
					white-space nowrap

					&::after
						content ""
						margin-left .5em
						border-top 4px solid transparente
						border-bottom 4px solid transparente
						border-left 5px solid tint( azul, 60% )
						width 0
						height 0
						display inline-block
						vertical-align middle

		.operaciones
			font-size .75rem
			width auto // 20vw
			box-sizing border-box
			display flex
			justify-content flex-end
			align-items center

			.grupo
				display flex
				align-items center
				border-radius .5rem
				flex 0 1 48px
				min-width 0
				transition all 350ms
				box-sizing border-box
				padding 0

				&.activo
					// min-width 100%
					flex 1 0 auto
					background-color lighten( silver, 10% )
					padding 0 .5rem

					button
						margin 0

						&:hover
							background-color none

					.campo
						flex 1 0 auto
						margin .5rem

			.campo
				flex 0 1 0
				font-size calcRem( 12 )
				display flex
				align-items center
				color gris
				overflow hidden
				transition all 350ms

				input,
				select
					min-width initial
					display block
					padding .2em
					border none
					outline none
					width 100%
					color inherit
					font-size inherit
					line-height 1
					border 1px solid lighten( gris, 50% )
					border-radius .2rem

			button
				padding .5rem
				margin 0 .2rem
				border none
				background-color transparente
				color lighten( negro, 40% )
				border-radius 2rem
				cursor pointer

				&:hover
					background-color alpha( silver, 25% )
					color tint( azul, 20% )

				.vector
					width 24px
					height 24px

		.columnas
			display flex
			justify-content space-between
			align-items center
			padding 1rem .5rem

			.columna
				color lighten( negro, 40% )
				flex 2 1 30%

				&:first-child
					flex 2 1 40%

				&:last-child
					flex 0 0 200px

				h2
					margin 0 .5rem
					font-size calcRem( 12 )
					font-weight 500

	.listado
		grid-area listado
		background-color fondo_listado

	.detalle
		grid-area detalle
		margin 0

		.tarjeta
			margin-bottom .5rem

			.cartel
				display grid
				grid-template-areas "icono nombre" "icono descripcion"
				grid-column-gap .5rem
				grid-template-columns 1fr 3fr
				margin-bottom .5rem

				h3
					margin-bottom .5em
					font-size calcRem( 14 )
					font-weight bolder
					color tint( azul, 30% )

				p
					margin 0
					font-size calcRem( 12 )

				.iconoFichero
					grid-area icono
					width 100%

			.contenido
				padding 1rem
				color gris
				background-color tint( azul, 80% )

			.propiedades
				display grid
				grid-template-columns auto 1fr
				grid-column-gap 1em
				grid-row-gap .5em
				align-items end
				font-size calcRem( 12 )
				font-weight 300

				dt
					flex 1 0 50%
					font-weight bolder
					color tint( azul, 50% )

				dd
					flex 1 1 auto

			h4
				color tint( azul, 50% )
				font-size calcRem( 12 )
				margin-bottom .5rem

			p
				font-size calcRem( 10 )
				line-height 1.2
				font-weight 300
				margin-bottom 1em

			&.comentarios
				>>> .contenido
					background-color #fff
					padding 0

			.listaComentarios
				padding .5rem

				.itemComentario
					margin-bottom .5rem

			.comentar
				display grid
				grid-template-areas "texto texto texto" "foto nombre boton"
				grid-template-columns min-content 1fr 1fr
				grid-template-rows min-content min-content
				grid-gap .2rem .5rem
				align-items center

				textarea
					grid-area texto
					font-size calcRem( 10 )
					font-weight 300
					padding 1em
					background-color #F2F2F2
					border 1px solid #E6E6E6
					width 100%
					height 6em
					display block
					resize vertical

				figure
					align-self start
					grid-area foto
					width 48px
					height 48px
					border-radius 48px
					box-sizing border-box
					border 2px solid blanco
					background-color tint( azul, 60% )
					overflow hidden
					margin-left 1rem

				h3
					grid-area nombre
					text-align left
					color darken( gris, 50% )
					font-weight 500
					font-size calcRem( 10 )

				button
					grid-area boton
					font-size calcRem( 10 )
					font-weight 500
					line-height 1
					color blanco
					background-color tint( azul, 30% )
					border none
					padding .6rem .8rem
					border-radius 2rem

		.acciones
			flex 0 1 auto
			display flex
			justify-content space-between
			margin-bottom .5rem

			button
				flex 0 0 32px
				border none
				width 32px
				height 32px
				border-radius 1rem
				display flex
				align-items center
				justify-content center
				padding 0
				margin 0 .1rem
				cursor pointer
				color tint( azul, 40% )
				background-color transparente

				&:hover
					background-color tint( azul, 90% )

				.vector
					height 20px

					svg
						display block

			.eliminar
				color tint( rojo, 40% )
</style>
